# generate-redux-duck
This is a CLI tool that generates React-Redux components based on the Ducks pattern.
A basic boilerplate is generated for the component that is specified.

**Usage instructions:**

* Install globally on your machine by running this command: npm install -g generate-redux-duck
* Open your terminal and navigate to your project's root directory.
* Type generate-redux-duck -h for an explanation of how to use this CLI.

**Version 1.x.x:**

_Options explained:_

* --directory : This will be the parent directory of where the Duck will be generated. The component name will be the directory that will be generated within the --directory specified.
* --environment : This must be either "web" or "native". Web is for ReactJS and native is for React Native.

_Example usage:_

generate-redux-duck --directory ParentDirectoryOfDucks --environment web MyFirstReactWebComponent

generate-redux-duck --directory ParentDirectoryOfDucks --environment native MyFirstReactNativeComponent

**Version 2.x.x:**

_Non-redux components can also be generated._

_Jest test are also generated:_

* Enzyme must be installed
* Jest must be installed and configured to be able to run the boilerplate tests.
* Your Redux store must be imported into the ComponentName/tests/*.view.spec.js test for it to pass.

**Versions 3.x.x and greater**
* Lower kebab case is used for directory and file names.

_Options explained:_

* --directory : This will be the parent directory of where the Duck will be generated. The component name will be the directory that will be generated within the --directory specified.
* --environment : This must be either "web" or "native". Web is for ReactJS and native is for React Native.
* --redux: true/false. This specifies whether Redux integration should be done. If this option is set to false then only a React component and test will be generated. It defaults to true.

_Example usage:_

generate-redux-duck --directory ParentDirectoryOfDucks --environment web --redux true MyFirstReactWebComponentWithRedux
generate-redux-duck -d ParentDirectoryOfDucks -e web -r true MyFirstReactWebComponentWithRedux

generate-redux-duck --directory ParentDirectoryOfDucks --environment native --redux false MyFirstReactNativeComponentWithoutRedux
generate-redux-duck -d ParentDirectoryOfDucks -e native -r false MyFirstReactNativeComponentWithoutRedux