var chalk = require('chalk');
var fs=require('fs');

var addActionsObserver = function (directory, componentName,componentBaseFileName) {
    var self = this;
    self.componentName = componentName;
    self.componentBaseFileName=componentBaseFileName;
    self.directory = directory;
    self.componentDirectory = `${self.directory}/${self.componentBaseFileName}`;
    self.fullFileName=`${self.componentDirectory}/${self.componentBaseFileName}.actions.js`;

    self.Execute = function () {
        let fileData=`import {exampleDispatcher} from "./${self.componentBaseFileName}.dispatchers";
        
export const BoilerplateAsyncAction=function()
{
    return (dispatch, getState) => {
       /*Async thanks to redux-thunk*/
       dispatch(exampleDispatcher());
    };
};

export const BoilerplateSyncAction=function()
{
    return exampleDispatcher();
};

`;

        console.log(chalk.green(`Creating ${self.fullFileName}`));
        fs.writeFileSync(self.fullFileName,fileData);
    }
};

module.exports = addActionsObserver;
