var chalk = require('chalk');
var fs = require('fs');

var addComponentObserver = function (directory, componentName,componentBaseFileName,addRedux) {
    var self = this;
    self.componentName = componentName;
    self.componentBaseFileName=componentBaseFileName;
    self.directory = directory;
    self.addRedux=addRedux;
    self.componentDirectory = self.directory + '/' + self.componentBaseFileName;
    self.fullFileName = self.componentDirectory + '/' + self.componentBaseFileName + '.view.js';

    self.generateFileDataRedux=function(){
        return `import React, {Component} from 'react';
import PropTypes from 'prop-types';
import {connect} from 'react-redux';
import {bindActionCreators} from 'redux';
import {${self.componentName}Styles} from "./${self.componentBaseFileName}.styles";
import {BoilerplateAsyncAction,BoilerplateSyncAction} from "./${self.componentBaseFileName}.actions";

class ${self.componentName}Component extends Component {
    
    constructor(props){
        super(props);
    }
    
    render() {
        return (null);
    }
}

function mapStateToProps(state) {
    return {};
}

function mapDispatchToProps(dispatch) {
    return bindActionCreators({}, dispatch);
}

${self.componentName}Component.propTypes = {};

export default connect(mapStateToProps, mapDispatchToProps)(${self.componentName}Component);`;
    };

    self.generateFileDataNoRedux=function(){
        return `import React, {Component} from 'react';
import PropTypes from 'prop-types';
import {${self.componentName}Styles} from "./${self.componentBaseFileName}.styles";

export default class ${self.componentName}Component extends Component {
    
    constructor(props){
        super(props);
    }
    
    render() {
        return (null);
    }
}

${self.componentName}Component.propTypes = {};`;
    };

    self.Execute = function () {

        var FileData='';

        if(self.addRedux==='true')
        {
            FileData=self.generateFileDataRedux();
        }

        if(self.addRedux==='false')
        {
            FileData=self.generateFileDataNoRedux();
        }

        console.log(chalk.green('Creating ' + self.fullFileName));
        fs.writeFileSync(self.fullFileName, FileData);
    }
};

module.exports = addComponentObserver;
