var chalk = require('chalk');
var fs = require('fs');

var addDispatchersObserver = function (directory, componentName, componentBaseFileName) {
    var self = this;
    self.componentName = componentName;
    self.componentBaseFileName = componentBaseFileName;
    self.directory = directory;
    self.componentDirectory = self.directory + '/' + self.componentBaseFileName;
    self.fullFileName = self.componentDirectory + '/' + self.componentBaseFileName + '.dispatchers.js';

    self.Execute = function () {
        console.log(chalk.green('Creating ' + self.fullFileName));
        fs.writeFileSync(self.fullFileName, `
            import {${self.componentName}ActionTypes} from "./${self.componentBaseFileName}.types";
            const {EXAMPLE_ACTION}=${self.componentName}ActionTypes;

            export const exampleDispatcher=function(){
                return {
                    type:EXAMPLE_ACTION,
                    payload:{}
                };
            };
        `);
    }
};

module.exports = addDispatchersObserver;
