var chalk = require('chalk');
var fs = require('fs');

var addReducerObserver = function (directory, componentName,componentBaseFileName) {
    var self = this;
    self.componentName = componentName;
    self.componentBaseFileName=componentBaseFileName;
    self.directory = directory;
    self.componentDirectory = self.directory + '/' + self.componentBaseFileName;
    self.fullFileName = self.componentDirectory + '/' + self.componentBaseFileName + '.reducer.js';

    self.Execute = function () {
        console.log(chalk.green('Creating ' + self.fullFileName));
        fs.writeFileSync(self.fullFileName,`import {${self.componentName}DefaultState} from "./${self.componentBaseFileName}.state";
import {${self.componentName}ActionTypes} from "./${self.componentBaseFileName}.types";

export const ${self.componentName}Reducer=function(state = ${self.componentName}DefaultState , action) {
    const NewState=JSON.parse(JSON.stringify(state));
    const {type,payload}=action;
    return NewState;
};`);
    }
};

module.exports = addReducerObserver;
