var chalk = require('chalk');
var fs = require('fs');

var addTestsObserver = function (directory, componentName,componentBaseFileName,addRedux) {
    var self = this;
    self.componentName = componentName;
    self.componentBaseFileName=componentBaseFileName;
    self.directory = directory;
    self.addRedux=addRedux;
    self.componentDirectory = self.directory + '/' + self.componentBaseFileName;
    self.componentTest = self.componentDirectory + '/tests/' + self.componentBaseFileName + '.view.spec.js';
    self.unitTests = self.componentDirectory + '/tests/' + self.componentBaseFileName + '.unit.spec.js';

    self.GenerateFileContentComponentTest = function () {

        if(self.addRedux==='true')
        {
            return `import React,{Component} from 'react';
import { shallow } from 'enzyme';
import {Provider} from 'react-redux';
import store from '../../../redux/store';
import ${self.componentName}Component from '../${self.componentBaseFileName}.view.js';

describe('<${self.componentName}Component/>', () => {
  it('Should render <${self.componentName}Component/> ', () => {
    const wrapper = shallow(
    <Provider store={store}>
        <${self.componentName}Component/>
    </Provider>
   );
  });
});`
        }

        if(self.addRedux==='false')
        {
            return `import React,{Component} from 'react';
import { shallow } from 'enzyme';
import ${self.componentName}Component from '../${self.componentBaseFileName}.view.js';

describe('<${self.componentName}Component/>', () => {
  it('Should render <${self.componentName}Component/> ', () => {
    const wrapper = shallow(
        <${self.componentName}Component/>
   );
  });
});`
        }
    };

    self.GenerateFileContentUnitTest = function () {

        return `describe('${self.componentName}Component unit tests', () => {
        it('should run as boilerplate test', () => {
            expect(5+5).toBe(10);
        });
});`;
    };

    self.Execute = function () {
        console.log(chalk.green('Creating ' + self.componentTest));
        fs.writeFileSync(self.componentTest, self.GenerateFileContentComponentTest());
        console.log(chalk.green('Creating ' + self.unitTests));
        fs.writeFileSync(self.unitTests, self.GenerateFileContentUnitTest());
    }
};

module.exports = addTestsObserver;
